package es.edu.android.chat;

import io.socket.IOAcknowledge;
import io.socket.IOCallback;
import io.socket.SocketIO;
import io.socket.SocketIOException;

import java.net.MalformedURLException;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;

public class ChatActivity extends Activity {
	ToggleButton btConnect;
	Button btSend;
	SocketIO socket;
	EditText txtUsername, txtMessage;
	TextView txt;
	
	String TAG = "Chat";
//	final String SERVER = "http://migadepan.herokuapp.com";
	final String SERVER = "http://chat.plazaro.c9.io";
	
	ChatActivity activity;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_chat);
		
		activity = this;
		
		txt = (TextView) findViewById(R.id.txtMessageContainer);
		
		txtUsername = (EditText) findViewById(R.id.txtUsername);
		txtMessage = (EditText) findViewById(R.id.txtMessage);
		
		btConnect = (ToggleButton) findViewById(R.id.btConnect);
		btConnect.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				try {
					if (socket == null) {
						socket = new SocketIO(SERVER);
					}
					if (!socket.isConnected()) {
						socket.connect(new IOCallback() {

							@Override
							public void on(String event, IOAcknowledge acknowledge, Object... params) {
								if (event.equals("connection")) {
									Log.d("on", event);
									JSONObject jObject = new JSONObject();
									try {
										jObject.put("name", txtUsername.getText().toString());
										socket.emit("nick", jObject);
									} catch (JSONException e) {
										e.printStackTrace();
									}
								}
								else if (event.equals("chat")) {
									Log.d("on", event);
//									JSONObject jObject = (JSONObject) params[0];
//									try {
//										addMessage(jObject.get("user").toString(), jObject.get("message").toString(), jObject.get("date").toString());
//									} catch (JSONException e) {
//										e.printStackTrace();
//									}
//									JSONObject jsonObject = (JSONObject) params[0];
//									activity.addMessage("aa", "bb", "cc");
//									Toast.makeText(getApplicationContext(), "ola ke ase", Toast.LENGTH_SHORT).show();
//									activity.addMessage(params[0]);
								}
							}

							@Override
							public void onConnect() {
								Log.d("onConnect", "onConnect");
							}

							@Override
							public void onDisconnect() {
								Log.d("onDisconnect", "onDisconnect");
							}

							@Override
							public void onError(SocketIOException arg0) {
								Log.d("onError", "onError");
							}

							@Override
							public void onMessage(String arg0, IOAcknowledge arg1) {
								Log.d("onMessage", "String");
							}

							@Override
							public void onMessage(JSONObject arg0, IOAcknowledge arg1) {
								Log.d("onMessage", "JSONObject");
							}
						
						});
					}
					else {
						socket.disconnect();
					}
				} catch (MalformedURLException e) {
					e.printStackTrace();
				}
				btConnect.setChecked(socket.isConnected());
			}
		});
		
		btSend = (Button) findViewById(R.id.btSend);
		btSend.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				if (!txtUsername.getText().toString().isEmpty()){
					if (!txtMessage.getText().toString().isEmpty()) {
						JSONObject jObject = new JSONObject();
						try {
							jObject.put("message", txtMessage.getText().toString());
							socket.emit("chat", jObject);
						} catch (JSONException e) {
							e.printStackTrace();
						}
					}
					else {
						txtMessage.setError("Este campo es obligatorio");
					}
				}
				else {
					txtUsername.setError("Este campo es obligatorio");
				}
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the meSnu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_chat, menu);
		return true;
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
	}

	
	public void crearToast(Context context, String text, int duration) {
		Toast.makeText(context, text, duration).show();
	}
	
	public void addMessage(Object param) {
		JSONObject jObject = (JSONObject) param;
		try {
			activity.addMessage(jObject.get("user").toString(), jObject.get("message").toString(), jObject.get("date").toString());
		} catch (JSONException e) {
			e.printStackTrace();
		}
	}
	
	public void addMessage(String user, String message, String date) {
		
		
		activity.txt.setText(txt.getText() + "\nMensaje Recibido -> Usuario: " + user +
				"; Mensaje: " + message + "; Fecha: " + date);
		
//		TableLayout table = (TableLayout) findViewById(R.id.tableChat);
//		TableRow fila = new TableRow(activity);
//		
//		TableLayout.LayoutParams params = new TableLayout.LayoutParams();
//		params.height = TableLayout.LayoutParams.WRAP_CONTENT;
//		params.width = TableLayout.LayoutParams.WRAP_CONTENT;
//		
//		TextView labelUser = new TextView(activity);
//		labelUser.setText(user);
//		TextView labelMessage = new TextView(activity);
//		labelMessage.setText(message);
//		TextView labelFecha = new TextView(activity);
//		labelFecha.setText(date);
//		
//		fila.addView(labelUser, params);
//		fila.addView(labelMessage, params);
//		fila.addView(labelFecha, params);
//		
//		table.addView(fila);
	}

}
